
def carrylessAdd(x, y):
    return 42

def destructiveRemoveRepeats(L):
    return None

def patternedMessage(msg, pattern):
    return pattern

def bestStudentAndAvg(gradebook):
    return ""

def extractAssignStatements(text):
    return []

def bestScrabbleScore(dictionary, letterScores, hand):
    return None

#################################################
# Test Functions
#################################################


def testCarrylessAdd():
    print('Testing carrylessAdd()... ', end='')
    assert (carrylessAdd(785, 376) == 51)
    assert (carrylessAdd(0, 376) == 376)
    assert (carrylessAdd(785, 0) == 785)
    assert (carrylessAdd(30, 376) == 306)
    assert (carrylessAdd(785, 30) == 715)
    assert (carrylessAdd(12345678900, 38984034003) == 40229602903)
    print('Passed.')


#### destructiveRemoveRepeats ####

def testDestructiveRemoveRepeats():
    print("Testing destructiveRemoveRepeats()...", end="")
    a = [1,3,5,3,3,2,1,7,5]
    assert(destructiveRemoveRepeats(a) == None)
    assert(a == [1,3,5,2,7])
    b = [1,2,3,-2]
    assert(destructiveRemoveRepeats(b) == None)
    assert(b == [1,2,3,-2])
    print("Passed.")

#### patternedMessage ####

def testPatternedMessage():
    print("Testing patternedMessage()...", end="")
    parms = [
        ("Go Pirates!!!", """
***************
******   ******
***************
"""),
        ("Three Diamonds!", """
    *     *     *
   ***   ***   ***
  ***** ***** *****
   ***   ***   ***
    *     *     *
"""),
        ("Go Steelers!", """
                          oooo$$$$$$$$$$$$oooo
                      oo$$$$$$$$$$$$$$$$$$$$$$$$o
                   oo$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$o         o$   $$ o$
   o $ oo        o$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$o       $$ $$ $$o$
oo $ $ '$      o$$$$$$$$$    $$$$$$$$$$$$$    $$$$$$$$$o       $$$o$$o$
'$$$$$$o$     o$$$$$$$$$      $$$$$$$$$$$      $$$$$$$$$$o    $$$$$$$$
  $$$$$$$    $$$$$$$$$$$      $$$$$$$$$$$      $$$$$$$$$$$$$$$$$$$$$$$
  $$$$$$$$$$$$$$$$$$$$$$$    $$$$$$$$$$$$$    $$$$$$$$$$$$$$  '$$$
   '$$$'$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$     '$$$
    $$$   o$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$     '$$$o
   o$$'   $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$       $$$o
   $$$    $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$' '$$$$$$ooooo$$$$o
  o$$$oooo$$$$$  $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$   o$$$$$$$$$$$$$$$$$
  $$$$$$$$'$$$$   $$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$     $$$$'
 ''''       $$$$    '$$$$$$$$$$$$$$$$$$$$$$$$$$$$'      o$$$
            '$$$o     '$$$$$$$$$$$$$$$$$$'$$'         $$$
              $$$o          '$$'$$$$$$'           o$$$
               $$$$o                                o$$$'
                '$$$$o      o$$$$$$o'$$$$o        o$$$$
                  '$$$$$oo     '$$$$o$$$$$o   o$$$$'
                     '$$$$$oooo  '$$$o$$$$$$$$$'
                        '$$$$$$$oo $$$$$$$$$$
                                '$$$$$$$$$$$
                                    $$$$$$$$$$$$
                                     $$$$$$$$$$'
                                      '$$$'
""")]
    solns = [
        """
GoPirates!!!GoP
irates   !!!GoP
irates!!!GoPira
""",
        """
    T     h     r
   eeD   iam   ond
  s!Thr eeDia monds
   !Th   ree   Dia
    m     o     n
""",
        """
                          GoSteelers!GoSteeler
                      s!GoSteelers!GoSteelers!GoS
                   teelers!GoSteelers!GoSteelers!GoS         te   el er
   s ! Go        Steelers!GoSteelers!GoSteelers!GoSteel       er s! GoSt
ee l e rs      !GoSteeler    s!GoSteelers!    GoSteelers       !GoSteel
ers!GoSte     elers!GoSt      eelers!GoSt      eelers!GoSt    eelers!G
  oSteele    rs!GoSteele      rs!GoSteele      rs!GoSteelers!GoSteeler
  s!GoSteelers!GoSteelers    !GoSteelers!G    oSteelers!GoSt  eele
   rs!GoSteelers!GoSteelers!GoSteelers!GoSteelers!GoSteel     ers!
    GoS   teelers!GoSteelers!GoSteelers!GoSteelers!GoSteelers     !GoSt
   eele   rs!GoSteelers!GoSteelers!GoSteelers!GoSteelers!GoSt       eele
   rs!    GoSteelers!GoSteelers!GoSteelers!GoSteelers!Go Steelers!GoSteele
  rs!GoSteelers  !GoSteelers!GoSteelers!GoSteelers!GoS   teelers!GoSteelers
  !GoSteelers!G   oSteelers!GoSteelers!GoSteelers!Go     Steel
 ers!       GoSt    eelers!GoSteelers!GoSteelers!G      oSte
            elers     !GoSteelers!GoSteelers!         GoS
              teel          ers!GoSteel           ers!
               GoSte                                elers
                !GoSte      elers!GoSteele        rs!Go
                  Steelers     !GoSteelers!   GoStee
                     lers!GoSte  elers!GoSteeler
                        s!GoSteele rs!GoSteel
                                ers!GoSteele
                                    rs!GoSteeler
                                     s!GoSteeler
                                      s!GoS
"""
    ]
    parms = [("A-C D?", """
*** *** ***
** ** ** **
"""),
             ("A", "x y z"),
             ("The pattern is empty!", "")
             ]
    solns = [
        """
A-C D?A -CD
?A -C D? A-
""",
        "A A A",
        ""
    ]
    for i in range(len(parms)):
        msg, pattern = parms[i]
        soln = solns[i]
        soln = soln.strip("\n")
        observed = patternedMessage(msg, pattern)
        assert(observed == soln)
    print("Passed!")


#### bestStudentAndAvg ####

def testBestStudentAndAvg():
    print("Testing bestStudentAndAvg()...", end="")
    gradebook = """
# ignore  blank lines and lines starting  with  #'s
wilma,91,93
fred,80,85,90,95,100
betty,88
"""
    assert(bestStudentAndAvg(gradebook) == "wilma:92")
    gradebook = """
#   ignore  blank   lines   and lines   starting    with    #'s
wilma,93,95

fred,80,85,90,95,100
betty,88
"""
    assert(bestStudentAndAvg(gradebook) == "wilma:94")
    gradebook = "fred,0"
    assert(bestStudentAndAvg(gradebook) == "fred:0")
    gradebook = "fred,-1\nwilma,-2"
    assert(bestStudentAndAvg(gradebook) == "fred:-1")
    gradebook = "fred,100"
    assert(bestStudentAndAvg(gradebook) == "fred:100")
    gradebook = "fred,100,110"
    assert(bestStudentAndAvg(gradebook) == "fred:105")
    gradebook = "fred,49\nwilma" + ",50" * 50
    assert(bestStudentAndAvg(gradebook) == "wilma:50")
    print("Passed!")


#### extractAssignStatements ####

def testExtractAssignStatements():
    print("Testing extractAssignStatements...", end="")
    assert(extractAssignStatements("hello,class=15112  and anotherVar=42. The end") == [('class',15112), ('anotherVar',42)])
    assert(extractAssignStatements("  .-, anotherVar=42.") == [('anotherVar',42)])
    assert(extractAssignStatements("a=98,b=23232;c=543- --=-    d=-42.23") == [('a',98), ('b', 23232),('c',543)])
    print("Passed!")



#### bestScrabbleScore ####

def testBestScrabbleScore():
    print("Testing bestScrabbleScore()...", end="")
    def dictionary1(): return ["a", "b", "c"]
    def letterScores1(): return [1] * 26
    def dictionary2(): return ["xyz", "zxy", "zzy", "yy", "yx", "wow"]
    def letterScores2(): return [1 + (i % 5) for i in range(26)]
    assert(bestScrabbleScore(
            dictionary1(),
            letterScores1(),
            ["a", "c", "e"]) == (["a", "c"], 1))
    assert(bestScrabbleScore(
           dictionary1(),
           letterScores1(),
           ["b"]) == ("b", 1))
    assert(
        bestScrabbleScore(
            dictionary1(),
            letterScores1(),
            ["z"]) is None)
    assert(bestScrabbleScore(
            dictionary2(),
            letterScores2(),
            ["x", "y", "z"]) == (["xyz", "zxy"], 10))
    assert(bestScrabbleScore(
            dictionary2(),
            letterScores2(),
            ["x", "y", "z", "y"]) == (["xyz", "zxy", "yy"], 10))
    assert(bestScrabbleScore(
            dictionary2(),
            letterScores2(),
            ["x", "y", "q"]) == ("yx", 9))
    assert(bestScrabbleScore(
            dictionary2(),
            letterScores2(),
            ["y", "z", "z"]) == ("zzy", 7))
    assert(
        bestScrabbleScore(
            dictionary2(),
            letterScores2(),
            ["w", "x", "z"]) is None)
    print("Passed!")


#################################################
# testAll and main
#################################################

def testAll():
    # comment out the tests you do not wish to run!
    testCarrylessAdd()
    testDestructiveRemoveRepeats()
    testPatternedMessage()
    testBestStudentAndAvg()
    testExtractAssignStatements()
    testBestScrabbleScore()

def main():
    testAll()

if __name__ == '__main__':
    main()
